unit MainFrm;

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs,
  RVWithHeaderFooter, RichView, RVReport, RVStyle, Vcl.StdCtrls;

type
  TfrmMain = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.Button1Click(Sender: TObject);
var
  rvwhf: TRVReportHelperWithHeaderFooters;
  rv: TCustomRichView;
  W: Integer;
  HFType: TRVHFType;

  procedure FormatHelper(rvh: TRVReportHelper);
  begin
    // we will use only rv.DocParameters.Margins for calculating content width
    rvh.RichView.LeftMargin := 0;
    rvh.RichView.RightMargin := 0;
    rvh.RichView.TopMargin := 0;
    rvh.RichView.BottomMargin := 0;
    rvh.TargetPixelsPerInch := rv.Style.UnitsPixelsPerInch;
    rvh.Init(Canvas, W);
  end;


begin
  if not OpenDialog1.Execute or not SaveDialog1.Execute then
    exit;

  rvwhf := TRVReportHelperWithHeaderFooters.Create;
  try
    rvwhf.UseStyleTemplates := True;
    rv := rvwhf.MainDoc.RichView;
    // loading RTF
    if not rv.LoadRTF(OpenDialog1.FileName) then
    begin
      Application.MessageBox('Cannot open RTF file', 'Error', MB_OK or MB_ICONSTOP);
      exit;
    end;
    // we need to format document, it is necessary for saving DocX containing tables
    W := rv.Style.RVUnitsToStandardPixels(
      rv.DocParameters.PageWidth - rv.DocParameters.LeftMargin - rv.DocParameters.RightMargin,
      rv.DocParameters.Units);
    FormatHelper(rvwhf.MainDoc);
    for HFType := Low(TRVHFType) to High(TRVHFType) do
    begin
      FormatHelper(rvwhf.GetHeader(HFType));
      FormatHelper(rvwhf.GetFooter(HFType));
    end;
    // saving DocX
    if not rv.SaveDocX(SaveDialog1.FileName, False) then
      Application.MessageBox('Cannot create DocX file', 'Error', MB_OK or MB_ICONSTOP);
  finally
    rvwhf.Free;
  end;

end;

end.
